#include "enc28j60.h"
#include "spi.h"
#include "delay.h"
#include "usart.h"
#include "lwip_comm.h"
#include "led.h"

//////////////////////////////////////////////////////////////////////////////////	 
							  
//////////////////////////////////////////////////////////////////////////////////

dev_strucrt enc28j60_dev;

//ʼENC28J60
//macaddr:MACַ
//ֵ:0,ʼɹ;
//       1,ʼʧ;
u8 ENC28J60_Init(void)
{
	u8 version;
	u16 retry=0;
	int temp;
	
	GPIO_InitTypeDef GPIO_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;
	EXTI_InitTypeDef EXTI_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOC|RCC_APB2Periph_AFIO, ENABLE);	 //ʹPA,C˿ʱ
    	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;   	//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
 	GPIO_SetBits(GPIOA,GPIO_Pin_4);	//PA4ø
 	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;				//PC5  	  
 	GPIO_Init(GPIOC, &GPIO_InitStructure);
	GPIO_SetBits(GPIOC,GPIO_Pin_5);							//PC5
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_4;   			//жPC4
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	
	//PC4ⲿжϣж4
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOC,GPIO_PinSource4);
	
	EXTI_InitStructure.EXTI_Line = EXTI_Line4;
	EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
	EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
	EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	EXTI_Init(&EXTI_InitStructure);
	
	EXTI_ClearITPendingBit(EXTI_Line4); //ж1־λ
	
	NVIC_InitStructure.NVIC_IRQChannel = EXTI4_IRQn;			//ⲿж1
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;	//ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;			//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
						  
	SPI1_Init();    		//ʼSPI	 
	SPI_Cmd(SPI1, DISABLE); // SPI費ʹ

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;	//ͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;			//ʱյ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;		//ݲڵ1ʱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;			//NSSź
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;			//CRCֵĶʽ
	SPI_Init(SPI1, &SPI_InitStructure);  				//SPI_InitStructָĲʼSPIxĴ
	SPI_Cmd(SPI1, ENABLE); //ʹSPI
	
	SPI1_SetSpeed(SPI_BaudRatePrescaler_8);	//SPI1 SCKƵΪ36M/4=4.5Mhz
	//ʼMACַ
	temp=*(vu32*)(0x1FFFF7E8);	//ȡSTM32ΨһIDǰ24λΪMACַֽ
	enc28j60_dev.macaddr[0]=0;
	enc28j60_dev.macaddr[1]=0;
	enc28j60_dev.macaddr[2]=1;

	enc28j60_dev.macaddr[3]=(temp>>16)&0XFF;	//ֽSTM32ΨһID
	enc28j60_dev.macaddr[4]=(temp>>8)&0XFFF;
	enc28j60_dev.macaddr[5]=temp&0XFF;

	ENC28J60_RST=0;			//λENC28J60
	delay_ms(10);	 
	ENC28J60_RST=1;			//λ				    
	delay_ms(10);	
	ENC28J60_Write_Op(ENC28J60_SOFT_RESET,0,ENC28J60_SOFT_RESET);	//λ
	while(!(ENC28J60_Read(ESTAT)&ESTAT_CLKRDY)&&retry<250)	//ȴʱȶ
	{
		retry++;
		delay_ms(1);
	}	
	if(retry>=250)return 1; //ENC28J60ʼʧ
	version=ENC28J60_Get_EREVID();			//ȡENC28J60İ汾
	printf("ENC28J60 Version:%d\r\n",version);	
	
	enc28j60_dev.NextPacketPtr=RXSTART_INIT;
	//ջһӲѭFIFO ɡ
	//ĴERXSTH:ERXSTL ERXNDH:ERXNDL 
	//Ϊָ룬建ڴ洢еλá
	//ERXSTERXNDָֽھFIFOڡ
	//̫ӿڽֽʱЩֽڱ˳д
	//ջ ǵдERXND ָĴ洢Ԫ
	//ӲԶյһֽдERXST ָ
	//Ĵ洢Ԫ ˽ӲдFIFO ĵ
	//Ԫ
	//ýʼֽ	
	ENC28J60_Write(ERXSTL,RXSTART_INIT&0XFF);	//ýջʼַ8λ
	ENC28J60_Write(ERXSTH,RXSTART_INIT>>8);		//ýջʼַ8λ
	//ýսֽ
	ENC28J60_Write(ERXNDL,RXSTOP_INIT&0XFF);	
	ENC28J60_Write(ERXNDH,RXSTOP_INIT>>8);
	//÷ʼֽ
	ENC28J60_Write(ETXSTL,TXSTART_INIT&0XFF);
	ENC28J60_Write(ETXSTH,TXSTART_INIT>>8);
	//÷ͽֽ
	ENC28J60_Write(ETXNDL,TXSTOP_INIT&0XFF);
	ENC28J60_Write(ETXNDH,TXSTOP_INIT>>8);
	//ERXWRPTH:ERXWRPTL ĴӲFIFO 
	//ĸλдյֽڡ ָֻģڳ
	//յһݰӲԶָ롣 ָ
	//жFIFO ʣռĴС  8K-1500 
	//ýնָֽ
	ENC28J60_Write(ERXRDPTL,RXSTART_INIT&0XFF);
	ENC28J60_Write(ERXRDPTH,RXSTART_INIT>>8);
	//չ
	//UCENʹλ
	//ANDOR = 1 ʱ
	//1 = Ŀַ뱾MAC ַƥݰ
	//0 = ֹ
	//ANDOR = 0 ʱ
	//1 = Ŀַ뱾MAC ַƥݰᱻ
	//0 = ֹ
	//CRCENCRC Уʹλ
	//1 = CRC Чݰ
	//0 = CRC ǷЧ
	//PMENʽƥʹλ
	//ANDOR = 1 ʱ
	//1 = ݰϸʽƥ򽫱
	//0 = ֹ
	//ANDOR = 0 ʱ
	//1 = ϸʽƥݰ
	//0 = ֹ
	ENC28J60_Write(ERXFCON,ERXFCON_UCEN|ERXFCON_CRCEN|ERXFCON_PMEN);
	ENC28J60_Write(EPMM0,0X3F);
	ENC28J60_Write(EPMM1,0X30);
	ENC28J60_Write(EPMCSL,0Xf9);
	ENC28J60_Write(EPMCSH,0Xf7);
	//bit 0 MARXENMAC ʹλ
	//1 = MAC ݰ
	//0 = ֹݰ
	//bit 3 TXPAUSͣ֡ʹλ
	//1 = MAC ͣ֡ȫ˫ģʽµƣ
	//0 = ֹͣ֡
	//bit 2 RXPAUSͣ֡ʹλ
	//1 = յͣ֡ʱֹͣ
	//0 = Խյͣ֡
	ENC28J60_Write(MACON1,MACON1_MARXEN|MACON1_TXPAUS|MACON1_RXPAUS);
	//MACON2 еMARST λ㣬ʹMAC ˳λ״̬
	ENC28J60_Write(MACON2,0x00);
		//bit 7-5 PADCFG2:PACDFG0ԶCRC λ
	//111 = 0 ж֡64 ֽڳ׷һЧCRC
	//110 = Զ֡
	//101 = MAC Զ8100h ֶεVLAN Э֡Զ䵽64 ֽڳ
	//VLAN ֡60 ֽڳҪ׷һЧCRC
	//100 = Զ֡
	//011 = 0 ж֡64 ֽڳ׷һЧCRC
	//010 = Զ֡
	//001 = 0 ж֡60 ֽڳ׷һЧCRC
	//000 = Զ֡
	//bit 4 TXCRCENCRC ʹλ
	//1 = PADCFGΣMACڷ֡ĩβ׷һЧCRC PADCFG涨Ҫ
	//׷ЧCRC뽫TXCRCEN 1
	//0 = MAC׷CRC 4 ֽڣЧCRC 򱨸״̬
	//bit 0 FULDPXMAC ȫ˫ʹλ
	//1 = MACȫ˫ģʽ¡ PHCON1.PDPXMD λ1
	//0 = MACڰ˫ģʽ¡ PHCON1.PDPXMD λ㡣
	ENC28J60_Write(MACON3,MACON3_PADCFG0|MACON3_TXCRCEN|MACON3_FRMLNEN|MACON3_FULDPX);
	// ֡ 1518
	ENC28J60_Write(MAMXFLL,MAX_FRAMELEN&0XFF);
	ENC28J60_Write(MAMXFLH,MAX_FRAMELEN>>8);
	//ñԱĴMABBIPGʹ
	//ȫ˫ģʽʱӦʹ15h ̸üĴ
	//ʹð˫ģʽʱʹ12h б̡
	ENC28J60_Write(MABBIPG,0x15);
	//÷ǱԱĴĵֽ
	//MAIPGL Ӧʹ12h ̸üĴ
	//ʹð˫ģʽӦ̷ǱԱ
	//ĴĸֽMAIPGH Ӧʹ0Ch
	//̸üĴ
	ENC28J60_Write(MAIPGL,0x12);
	ENC28J60_Write(MAIPGH,0x0C);
	//MACַ
	ENC28J60_Write(MAADR5,enc28j60_dev.macaddr[0]);
	ENC28J60_Write(MAADR4,enc28j60_dev.macaddr[1]);
	ENC28J60_Write(MAADR3,enc28j60_dev.macaddr[2]);
	ENC28J60_Write(MAADR2,enc28j60_dev.macaddr[3]);
	ENC28J60_Write(MAADR1,enc28j60_dev.macaddr[4]);
	ENC28J60_Write(MAADR0,enc28j60_dev.macaddr[5]);
	//PHYΪȫ˫  LEDBΪ
	ENC28J60_PHY_Write(PHCON1,PHCON1_PDPXMD);	
	//HDLDISPHY ˫ؽֹλ
	//PHCON1.PDPXMD = 1 PHCON1.PLOOPBK = 1 ʱ
	//λɱԡ
	//PHCON1.PDPXMD = 0 PHCON1.PLOOPBK = 0 ʱ
	//1 = Ҫ͵ݽͨ˫߽ӿڷ
	//0 = Ҫ͵ݻỷصMAC ͨ˫߽ӿڷ
	ENC28J60_PHY_Write(PHCON2,PHCON2_HDLDIS);
	//ECON1 Ĵ
	//Ĵ3-1 ʾΪECON1 Ĵڿ
	//ENC28J60 Ҫܡ ECON1 аʹܡ
	//DMA ƺʹ洢ѡλ	   
	ENC28J60_Set_Bank(ECON1);
	//EIE ̫жĴ
	//bit 7 INTIE ȫINT жλ
	//1 = ж¼INT 
	//0 = ֹINT ŵĻʼձΪߵƽ
	//bit 6 PKTIE ݰжλ
	//1 = ݰж
	//0 = ֹݰж
	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,EIE,EIE_INTIE|EIE_PKTIE|EIE_TXIE|EIE_TXERIE|EIE_RXERIE);
	// enable packet reception
	//bit 2 RXENʹλ
	//1 = ͨǰݰдջ
	//0 = нյݰ
	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,ECON1,ECON1_RXEN);
	printf("ENC28J60 Duplex:%s\r\n",ENC28J60_Get_Duplex()?"Full Duplex":"Half Duplex");	//ȡ˫ʽ
	return 0;
}

//ȡENC28J60ƼĴ()
//op
//addr:Ĵַ/
//ֵ:
u8 ENC28J60_Read_Op(u8 op,u8 addr)
{
	u8 dat=0;
	ENC28J60_CS=0;
	dat=op|(addr&ADDR_MASK);
	SPI1_ReadWriteByte(dat);
	dat=SPI1_ReadWriteByte(0XFF);
	//ǶȡMAC/MIIĴ,ڶζݲȷ,ֲ29ҳ
	if(addr&0x80)dat=SPI1_ReadWriteByte(0XFF);	
	ENC28J60_CS=1;
	return dat;	
}

//ENC28J60Ĵд()
//op
//addr:Ĵַ
//data:
void ENC28J60_Write_Op(u8 op,u8 addr,u8 data)
{
	u8 dat=0;
	ENC28J60_CS=0;
	dat=op|(addr&ADDR_MASK);
	SPI1_ReadWriteByte(dat);
	SPI1_ReadWriteByte(data);
	ENC28J60_CS=1;
}

//ȡENC28J60ջ
//len:Ҫȡݳ
//data:ݻ(ĩβԶӽ)
void ENC28J60_Read_Buf(u32 len,u8* data)
{
	ENC28J60_CS=0;
	SPI1_ReadWriteByte(ENC28J60_READ_BUF_MEM);
	while(len)
	{
		len--;
		*data=(u8)SPI1_ReadWriteByte(0);
		data++; 
	}
	*data='\0';
	ENC28J60_CS=1;
}

//ENC28J60дͻ
//len:Ҫдݳ
//data:ݻ 
void ENC28J60_Write_Buf(u32 len,u8* data)
{
	ENC28J60_CS=0;
	SPI1_ReadWriteByte(ENC28J60_WRITE_BUF_MEM);
	while(len)
	{
		len--;
		SPI1_ReadWriteByte(*data);
		data++;
	}
	ENC28J60_CS=1;
}

//ENC28J60ĴBank
//ban:Ҫõbank
void ENC28J60_Set_Bank(u8 bank)
{
	if((bank&BANK_MASK)!=enc28j60_dev.enc28j60bank)	//͵ǰbankһµʱ
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,ECON1,(ECON1_BSEL1|ECON1_BSEL0));
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,ECON1,(bank&BANK_MASK)>>5);
		enc28j60_dev.enc28j60bank=(bank&BANK_MASK);
	}
}

//ȡENC28J60ָĴ 
//addr:Ĵַ
//ֵ:
u8 ENC28J60_Read(u8 addr)
{
	ENC28J60_Set_Bank(addr);	//BANK
	return ENC28J60_Read_Op(ENC28J60_READ_CTRL_REG,addr);
}

//ENC28J60ָĴд
//addr:Ĵַ
//data:Ҫд	
void ENC28J60_Write(u8 addr,u8 data)
{
	ENC28J60_Set_Bank(addr);
	ENC28J60_Write_Op(ENC28J60_WRITE_CTRL_REG,addr,data);
}

//ENC28J60PHYĴд
//addr:Ĵַ
//data:Ҫд	
void ENC28J60_PHY_Write(u8 addr,u16 data)
{
	u16 retry=0;
	ENC28J60_Write(MIREGADR,addr);		//MIREGADRдPHYĴַ
	ENC28J60_Write(MIWRL,data);			//дݵĵ8ֽ
	ENC28J60_Write(MIWRH,data>>8);		//дݵĸ8ֽ
	while((ENC28J60_Read(MISTAT)&MISTAT_BUSY)&&retry<0XFFFF)retry++;	//ȴдPHY
}

//ȡENC28J60PHYĴ
//addr:ҪȡļĴַ
//ֵ:ȡPHYֵ
u16 ENC28J60_PHY_Read(u8 addr)
{
	u8 temp;
	u16 phyvalue,retry=0;
	temp=ENC28J60_Read(MICMD);
	ENC28J60_Write(MIREGADR,addr);
	ENC28J60_Write(MICMD,temp|MICMD_MIIRD);		//ʼPHYĴ
	while((ENC28J60_Read(MISTAT)&MISTAT_BUSY)&&retry<0XFFFF)retry++;	//ȴPHY
	ENC28J60_Write(MICMD,temp&(~MICMD_MIIRD));	//PHY
	phyvalue=ENC28J60_Read(MIRDL);			//ȡ8λ
	phyvalue|=(ENC28J60_Read(MIRDH)<<8);	//ȡ8λ
	return phyvalue;
}

//ȡENC28J60İ汾
//ֵ:ENC28J60汾
u8 ENC28J60_Get_EREVID(void)
{
	//EREVID Ҳ洢˰汾Ϣ EREVID һֻ
	//ƼĴһ5 λʶʶضƬ
	//İ汾
	return ENC28J60_Read(EREVID)&0X1F;
}

//ȡENC28J60˫״̬
//ֵ:1ȫ˫0˫
u16 ENC28J60_Get_Duplex(void)
{
	u16 temp;
	temp=ENC28J60_PHY_Read(PHCON1)&0X0100;
	return (temp>>8);
}


//ͨENC28J60ݰ
//len:ݰС
//packet:ݰ
void ENC28J60_Packet_Send(u32 len,u8* packet)
{
	INTX_DISABLE();
	while(ENC28J60_Read(ECON1)&0X08);		//ڷݣȴ
	if(len>MAX_FRAMELEN)
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,MACON3,MACON3_HFRMEN);
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,0X0E,PKTCTRL_POVERRIDE|PKTCTRL_PHUGEEN);
	}
	//÷ͻַдָ
	ENC28J60_Write(EWRPTL,TXSTART_INIT&0XFF);
	ENC28J60_Write(EWRPTH,TXSTART_INIT>>8);
	//TXNDָ룬ԶӦݰС	
	ENC28J60_Write(ETXNDL,(TXSTART_INIT+len)&0XFF);
	ENC28J60_Write(ETXNDH,(TXSTART_INIT+len)>>8);
	//дÿֽڣ0x00ʾʹmacon3ã 
	ENC28J60_Write_Op(ENC28J60_WRITE_BUF_MEM,0,0x00);
	//ݰͻ
 	ENC28J60_Write_Buf(len,packet);
	//ݵ
	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,ECON1,ECON1_TXRTS);
	//λ߼⡣μRev. B4 Silicon Errata point 12.
	if((ENC28J60_Read(EIR)&EIR_TXERIF))ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,ECON1,ECON1_TXRTS);
	INTX_ENABLE();
}

//ȡһݰ
//maxlen:ݰճ
//packet:ݰ
//ֵ:յݰ(ֽ)									  
u32 ENC28J60_Packet_Receive(u32 maxlen,u8* packet)
{
	u32 rxstat;
	u32 len;  
	INTX_DISABLE();
	if(ENC28J60_Read(EPKTCNT)==0)return 0;  //Ƿյݰ?	
	while((ENC28J60_Read(ESTAT)&0X04));		//æȴ	
	//ýջָ
	ENC28J60_Write(ERDPTL,(enc28j60_dev.NextPacketPtr));
	ENC28J60_Write(ERDPTH,(enc28j60_dev.NextPacketPtr)>>8);	   
	// һָ
	enc28j60_dev.NextPacketPtr=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0);
	enc28j60_dev.NextPacketPtr|=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0)<<8;
	//ĳ
	len=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0);
	len|=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0)<<8;
 	len-=4; //ȥCRC
	//ȡ״̬
	rxstat=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0);
	rxstat|=ENC28J60_Read_Op(ENC28J60_READ_BUF_MEM,0)<<8;
	//ƽճ	
	if (len>maxlen-1)len=maxlen-1;	
	//CRCͷŴ
	// ERXFCON.CRCENΪĬ,һǲҪ.
	if((rxstat&0x80)==0)len=0;//Ч
	else 
	{
		ENC28J60_Read_Buf(len,packet);//ӽջиݰ
	}
	//RXָƶһյݰĿʼλ 
	//ͷǸղŶڴ
	ENC28J60_Write(ERXRDPTL,(enc28j60_dev.NextPacketPtr));
	ENC28J60_Write(ERXRDPTH,(enc28j60_dev.NextPacketPtr)>>8);
	//ݼݰ־Ѿõ 
 	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,ECON2,ECON2_PKTDEC);
	INTX_ENABLE();
	return(len);
}

//жϴ
void ENC28J60_ISRHandler(void)
{
	u8 status;
	u8 packetnum;
	u16 temp;
	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,EIE,EIE_INTIE);	//رENC28J60ȫж
	status=ENC28J60_Read(EIR);	//ȡ̫жϱ־Ĵ
	if(status&EIR_PKTIF)		//յ,
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,EIR,EIR_PKTIF);	//ENC28J60Ľжϱ־λ
		lwip_pkt_handle() ;
	}
	if(status&EIR_TXIF)			//̫ж
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,EIR,EIR_TXIF);	//ENC28J60Ľжϱ־λ
		
	}
	if(status&EIR_RXERIF)		//մжϱ־λ
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,EIR,EIR_RXERIF);	
		packetnum=ENC28J60_Read(EPKTCNT);
		temp=ENC28J60_Read(ERXRDPTH)<<8;		//ȡֽ
		temp|=ENC28J60_Read(ERXRDPTL);			//ȡֽ
		temp++;
		ENC28J60_Write(ERXRDPTL,temp&0XFF);		//дֽ
		ENC28J60_Write(ERXRDPTH,temp>>8);		//дֽ
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,ECON2,ECON2_PKTDEC);
		printf("մ󣡽յݰ:%d\r\n",packetnum);
	}
	if(status&EIR_TXERIF)		//ʹжϱ־λ
	{
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,EIR,EIR_TXERIF);
		ENC28J60_Write_Op(ENC28J60_BIT_FIELD_CLR,ESTAT,ESTAT_LATECOL|ESTAT_TXABRT);
		printf("ʹ!\r\n");
	}
	ENC28J60_Write_Op(ENC28J60_BIT_FIELD_SET,EIE,EIE_INTIE);	//ENC28J60ȫж
}

//ⲿж1жϷ
void EXTI4_IRQHandler(void)
{
	EXTI_ClearITPendingBit(EXTI_Line4); //ж4־λ
	while(ENC28J60_INT == 0)
	{
		ENC28J60_ISRHandler();
	}										 
}




